Attribute VB_Name = "modMain"
'Main Module
'
'Contains regular functions and global variables

Private Type typeForLoop
    Var As String
    VarMax As Long
    Step As Integer
    Location As Long
End Type

Public dScript As String, iLocation As Long

Public ProcReturns() As typeVar, ReturnCount As Integer
Public ForLoops() As typeForLoop, ForLoopDepth As Integer
Public Socks() As String, SockCount As Integer
Public appDOS As Boolean

Public DOS As New Console
Public CurrentProc As String
Public hasFunctions As Boolean

Public Function StringExist(ByVal StartPos As Long, ByVal SourceText As String, ByVal ToFind As String) As Boolean
    'determines if a string exists in another string
    If CodeInStr(StartPos, LCase(SourceText), LCase(ToFind)) = 0 Then
        StringExist = False
    Else
        StringExist = True
    End If
End Function

Public Function AppPath() As String
'This gets the app's path
If Right(App.Path, 1) = "\" Then AppPath = App.Path Else AppPath = App.Path & "\"
End Function

Function Crypt(Text) As String
'This is a simple crypter
For i = 1 To Len(Text)
    DoEvents
    Crypt = Crypt & Chr(255 - Asc(Mid(Text, i, 1)))
Next i
End Function

Public Sub Pause(interval)
    'pauses execution
    Current = Timer
    Do While Timer - Current < Val(interval)
        DoEvents
    Loop
End Sub

Public Function CodeInStr(ByVal StartPos As Long, ByVal SourceText As String, ByVal ToFind As String) As Long
'This is just like InStr() only it skips over ""'s
Dim iPend As Long, i As Long
Dim sTemp As String

For i = StartPos To Len(SourceText)
    If LCase(Mid(SourceText, i, Len(ToFind))) = LCase(ToFind) Then
        CodeInStr = i
        Exit Function
    End If
                          
    If Mid(SourceText, i, 1) = Chr(34) Then
        Quote = InStr(i + 1, SourceText, Chr(34))
        If Quote <> 0 Then
            i = InStr(i + 1, SourceText, Chr(34))
        Else
            FlagError "Syntax Error", "Expected character 34" & vbCrLf & "History: CodeInStr: [ToFind: " & ToFind & "] [Start: " & StartPos & "] [Source: " & SourceText & "]", iLocation: Exit Function
        End If
    End If
Next i
End Function

Public Function FileExist(ByVal FileName As String) As Boolean
'Determines if a file exists
On Error Resume Next
If Dir(FileName, vbSystem + vbHidden) = "" Then
    FileExist = False
Else
    FileExist = True
End If
End Function

Public Sub FlagError(Title As String, ErrorText As String, Location As Long)
hasError = True
'frmRun.Hide
'frmRun.UnloadAllWinsocks
Unload frmRun

frmError.lblType = Title
frmError.txtError = ErrorText
If Location = -1 Then
    frmError.txtChar = "Unknown"
Else
    If CurrentProc <> "" Then
        frmError.txtChar = GetProcLoc(CurrentProc) + Location
    Else
        frmError.txtChar = Location
    End If
End If
If CurrentProc = "" Then
    If frmRun.Running Then
        CurrentProc = "(Main)"
    Else
        CurrentProc = "(Preprocesser)"
    End If
End If
frmError.txtProc = CurrentProc
Load frmError
If Command = "debug" Then frmError.Caption = "D++ Error - [DEVMODE]"
Beep
frmError.Show 1
End Sub

Public Function dSplit(ByVal expression As String, ByVal delimiter As String) As String()
'like split(), however it skips over quotes and parenthesis
Dim SplitArray() As String
Dim TempLetter As String
Dim TempSplit As String
Dim i As Integer
Dim x As Integer
Dim StartPos As Integer
    
expression = expression & delimiter
For i = 1 To Len(expression)
    If Mid(expression, i, 1) = Chr(34) Then
        If InStr(i + 1, expression, Chr(34)) = 0 Then
            FlagError "Syntax Error", "Expected character 34", iLocation: Exit Function
            i = i + 1
        Else
            i = InStr(i + 1, expression, Chr(34))
        End If
    End If
    If Mid(expression, i, 1) = "(" Then
        If InStr(i + 1, expression, ")") = 0 Then
            FlagError "Syntax Error", "Expected ')'", iLocation: Exit Function
            i = i + 1
        Else
            i = InStr(i + 1, expression, ")")
        End If
    End If
    TempLetter = Mid(expression, i, Len(delimiter))
    If TempLetter = delimiter Then
        TempSplit = Mid(expression, (StartPos + 1), (i - StartPos) - 1)
        If TempSplit <> "" Then
            ReDim Preserve SplitArray(0 To x)
            SplitArray(x) = TempSplit
            x = x + 1
        End If
        StartPos = i
    End If
Next i
dSplit = SplitArray
End Function

Public Function GetFileName(FullPath As String) As String
On Error Resume Next
'This parses a full path to get the file name
For i = Len(FullPath) To 1 Step -1
    sChar = Mid(FullPath, i, 1)
    If sChar = "\" Then
        GetFileName = StrReverse(GetFileName)
        Exit For
    End If
    GetFileName = GetFileName & sChar
Next i
End Function

Public Function ReadEXE(sPath As String) As String
'Reads an EXE file and gets D++ source
On Error GoTo Errorh
Dim FileData As String
Dim Header As String, EXE_Type As String, Encrypt_Source As String
    
Open sPath For Binary As #1
    FileData = Space$(LOF(1))
    Get #1, , FileData
Close #1

If InStr(1, FileData, "dppapp:") = 0 Or InStr(1, FileData, "dpp:") = 0 Then
    ReadEXE = "screenput " & Chr(34) & "Note: No source code found." & Chr(34) & ";"
    Exit Function
End If

Header = Mid(FileData, InStr(1, FileData, "dppapp:"), 35)
EXE_Type = Mid(Header, 13, 3)
Encrypt_Source = Mid(Header, 23, 1)

Select Case EXE_Type
    Case "dos"
        appDOS = True
    Case "dpp"
        appDOS = False
    Case "reg"
        SaveSetting "D++", "Version", "DLL_Version", App.Revision
        End
    Case Else
        MsgBox "Link error: Incorrect application type.  Please recompile." & vbCrLf & vbCrLf & "If this message continues, please download the latest D++ compiler at " & vbCrLf & vbCrLf & "http://squeakmac.tripod.com", vbCritical, "Invalid App Type"
        End
End Select

If Encrypt_Source = "T" Then 'Parse file to get source
    ReadEXE = Crypt(Mid(FileData, InStr(1, FileData, "dpp:") + 4))
ElseIf Encrypt_Source = "F" Then
    ReadEXE = Mid(FileData, InStr(1, FileData, "dpp:") + 4)
Else
    MsgBox "Link error: Incorrect application type.  Please recompile and make sure you have version 3.0 of the IDE" & vbCrLf & vbCrLf & "If this message continues, please download the latest D++ compiler at " & vbCrLf & vbCrLf & "http://squeakmac.tripod.com", vbCritical, "Invalid App Type"
    End
End If

'remove tag from
a = InStr(1, ReadEXE, "begindpp>")
If a <> 0 Then
    ReadEXE = Left(ReadEXE, a - 1) & Mid(ReadEXE, a + 9)
End If

Exit Function

Errorh:
FlagError "Fatal Link Error", err.Description, -1: Exit Function
End Function

Public Function FindEncloseEnd(ByVal Start As Long, ByVal InWhat As String, ByVal Encloser As String) As Long
    Dim Depth As Integer, Quote As Long
    Dim encloseOpen As String, encloseClose As String
    
    encloseOpen = IIf(Encloser = "[", "[", "(")
    encloseClose = IIf(Encloser = "[", "]", ")")
    
    For i = Start To Len(InWhat)
        sChar = Mid(InWhat, i, 1)
        If sChar = encloseOpen Then
            Depth = Depth + 1
        ElseIf sChar = encloseClose Then
            If Depth = 0 Then
                FindEncloseEnd = i
                Exit Function
            Else
                Depth = Depth - 1
            End If
        ElseIf sChar = Chr(34) Then
            Quote = InStr(i + 1, InWhat, Chr(34))
            If Quote <> 0 Then
                i = Quote
            End If
        End If
    Next 'i
End Function

Public Function doFileOpen(ByVal FilePath As String, ByVal FileMode As String) As Integer
    On Error GoTo fileErr
    Dim tempInt As Integer
    
    tempInt = FreeFile
    
    Select Case FileMode
        Case "w"
            Open FilePath For Output As #tempInt
        Case "r"
            Open FilePath For Input As #tempInt
        Case "a"
            Open FilePath For Append As #tempInt
        Case "b"
            Open FilePath For Binary As #tempInt
        Case Else
            FlagError "Syntax Error", "Invalid file mode: " & FileMode, iLocation
    End Select
    
    doFileOpen = tempInt
    Exit Function
    
fileErr:
    FlagError "Run-Time Error", "Error opening '" & FilePath & "': " & err.Description, iLocation
End Function

